'use strict';

const index = require('./index-e8963331.js');

/*
 Stencil Client Patch Browser v2.2.0 | MIT Licensed | https://stenciljs.com
 */
const patchBrowser = () => {
    const importMeta = (typeof document === 'undefined' ? new (require('u' + 'rl').URL)('file:' + __filename).href : (document.currentScript && document.currentScript.src || new URL('vime.cjs.js', document.baseURI).href));
    const opts =  {};
    if ( importMeta !== '') {
        opts.resourcesUrl = new URL('.', importMeta).href;
    }
    return index.promiseResolve(opts);
};

patchBrowser().then(options => {
  return index.bootstrapLazy(JSON.parse("[[\"vime-embed.cjs\",[[0,\"vime-embed\",{\"embedSrc\":[1,\"embed-src\"],\"mediaTitle\":[1,\"media-title\"],\"params\":[1],\"origin\":[1],\"preconnections\":[16],\"decoder\":[16],\"srcWithParams\":[32],\"hasEnteredViewport\":[32],\"postMessage\":[64]},[[8,\"message\",\"onWindowMessage\"]]]]],[\"vime-slider.cjs\",[[0,\"vime-slider\",{\"step\":[2],\"min\":[2],\"max\":[2],\"value\":[2],\"valueText\":[1,\"value-text\"],\"label\":[1]}]]],[\"vime-file_2.cjs\",[[4,\"vime-video\",{\"willAttach\":[4,\"will-attach\"],\"crossOrigin\":[1,\"cross-origin\"],\"preload\":[1],\"poster\":[1],\"controlsList\":[1,\"controls-list\"],\"autoPiP\":[4,\"auto-pip\"],\"disablePiP\":[4,\"disable-pip\"],\"disableRemotePlayback\":[4,\"disable-remote-playback\"],\"mediaTitle\":[1,\"media-title\"],\"getAdapter\":[64]}],[4,\"vime-file\",{\"willAttach\":[4,\"will-attach\"],\"crossOrigin\":[1,\"cross-origin\"],\"preload\":[1],\"poster\":[1],\"mediaTitle\":[1,\"media-title\"],\"controlsList\":[1,\"controls-list\"],\"autoPiP\":[4,\"auto-pip\"],\"disablePiP\":[4,\"disable-pip\"],\"disableRemotePlayback\":[4,\"disable-remote-playback\"],\"viewType\":[1,\"view-type\"],\"playbackRates\":[16],\"language\":[1],\"autoplay\":[4],\"controls\":[4],\"logger\":[16],\"loop\":[4],\"muted\":[4],\"playsinline\":[4],\"noConnect\":[4,\"no-connect\"],\"paused\":[4],\"currentTime\":[2,\"current-time\"],\"playbackStarted\":[4,\"playback-started\"],\"getAdapter\":[64]}]]],[\"vime-control_3.cjs\",[[4,\"vime-control\",{\"keys\":[1],\"identifier\":[1],\"hidden\":[4],\"label\":[1],\"menu\":[1],\"expanded\":[4],\"pressed\":[4],\"isTouch\":[4,\"is-touch\"],\"describedBy\":[32],\"showTapHighlight\":[32]}],[4,\"vime-tooltip\",{\"hidden\":[4],\"active\":[4],\"position\":[1],\"direction\":[1],\"isTouch\":[4,\"is-touch\"]}],[4,\"vime-icon\",{\"href\":[1]}]]],[\"vime-menu_2.cjs\",[[0,\"vime-menu-item\",{\"identifier\":[1],\"hidden\":[4],\"label\":[1],\"menu\":[1],\"expanded\":[4],\"checked\":[4],\"hint\":[1],\"badge\":[1],\"checkedIcon\":[1,\"checked-icon\"],\"isTouch\":[4,\"is-touch\"],\"showTapHighlight\":[32]}],[4,\"vime-menu\",{\"active\":[1540],\"identifier\":[1],\"controller\":[1],\"menuItems\":[32],\"currFocusedMenuItem\":[32],\"getController\":[64],\"getFocusedMenuItem\":[64],\"focusOnOpen\":[64]},[[0,\"vOpen\",\"onSubmenuOpen\"],[0,\"vClose\",\"onSubmenuClose\"],[8,\"click\",\"onWindowClick\"],[8,\"keydown\",\"onWindowKeyDown\"]]]]],[\"vime-current-time_4.cjs\",[[0,\"vime-mute-control\",{\"lowVolumeIcon\":[1,\"low-volume-icon\"],\"highVolumeIcon\":[1,\"high-volume-icon\"],\"mutedIcon\":[1,\"muted-icon\"],\"tooltipPosition\":[1,\"tooltip-position\"],\"tooltipDirection\":[1,\"tooltip-direction\"],\"hideTooltip\":[4,\"hide-tooltip\"],\"keys\":[1],\"volume\":[2],\"muted\":[4],\"i18n\":[16]}],[0,\"vime-current-time\",{\"currentTime\":[2,\"current-time\"],\"i18n\":[16],\"alwaysShowHours\":[4,\"always-show-hours\"]}],[0,\"vime-end-time\",{\"duration\":[2],\"i18n\":[16],\"alwaysShowHours\":[4,\"always-show-hours\"]}],[0,\"vime-time\",{\"label\":[1],\"seconds\":[2],\"alwaysShowHours\":[4,\"always-show-hours\"]}]]],[\"vime-caption-control_27.cjs\",[[0,\"vime-default-controls\",{\"activeDuration\":[2,\"active-duration\"],\"waitForPlaybackStart\":[4,\"wait-for-playback-start\"],\"hideWhenPaused\":[4,\"hide-when-paused\"],\"hideOnMouseLeave\":[4,\"hide-on-mouse-leave\"],\"theme\":[1],\"isMobile\":[4,\"is-mobile\"],\"isLive\":[4,\"is-live\"],\"isAudioView\":[4,\"is-audio-view\"],\"isVideoView\":[4,\"is-video-view\"]}],[4,\"vime-default-settings\",{\"pin\":[513],\"i18n\":[16],\"playbackReady\":[4,\"playback-ready\"],\"playbackRate\":[2,\"playback-rate\"],\"playbackRates\":[16],\"playbackQuality\":[1,\"playback-quality\"],\"playbackQualities\":[16],\"isCaptionsActive\":[4,\"is-captions-active\"],\"currentCaption\":[16],\"textTracks\":[16]}],[0,\"vime-captions\",{\"hidden\":[4],\"controlsHeight\":[2,\"controls-height\"],\"isControlsActive\":[4,\"is-controls-active\"],\"isVideoView\":[4,\"is-video-view\"],\"playbackStarted\":[4,\"playback-started\"],\"textTracks\":[16],\"isEnabled\":[32],\"activeTrack\":[32],\"activeCues\":[32]}],[0,\"vime-click-to-play\",{\"useOnMobile\":[4,\"use-on-mobile\"],\"paused\":[4],\"isVideoView\":[4,\"is-video-view\"]}],[0,\"vime-dbl-click-fullscreen\",{\"useOnMobile\":[4,\"use-on-mobile\"],\"isFullscreenActive\":[4,\"is-fullscreen-active\"],\"isVideoView\":[4,\"is-video-view\"],\"playbackReady\":[4,\"playback-ready\"],\"canSetFullscreen\":[32]}],[0,\"vime-icons\",{\"href\":[1]}],[0,\"vime-poster\",{\"fit\":[1],\"isVideoView\":[4,\"is-video-view\"],\"currentPoster\":[1,\"current-poster\"],\"mediaTitle\":[1,\"media-title\"],\"playbackStarted\":[4,\"playback-started\"],\"currentTime\":[2,\"current-time\"],\"isHidden\":[32],\"isActive\":[32],\"hasLoaded\":[32]}],[0,\"vime-skeleton\",{\"effect\":[1],\"ready\":[4],\"hidden\":[32]}],[0,\"vime-spinner\",{\"isVideoView\":[4,\"is-video-view\"],\"currentProvider\":[1,\"current-provider\"],\"buffering\":[4],\"isHidden\":[32],\"isActive\":[32]}],[4,\"vime-ui\",{\"isVideoView\":[4,\"is-video-view\"],\"playsinline\":[4],\"isFullscreenActive\":[4,\"is-fullscreen-active\"]}],[0,\"vime-volume-control\",{\"lowVolumeIcon\":[1,\"low-volume-icon\"],\"highVolumeIcon\":[1,\"high-volume-icon\"],\"mutedIcon\":[1,\"muted-icon\"],\"tooltipPosition\":[1,\"tooltip-position\"],\"tooltipDirection\":[1,\"tooltip-direction\"],\"hideTooltip\":[4,\"hide-tooltip\"],\"muteKeys\":[1,\"mute-keys\"],\"noKeyboard\":[4,\"no-keyboard\"],\"muted\":[4],\"volume\":[2],\"isMobile\":[4,\"is-mobile\"],\"i18n\":[16],\"currentVolume\":[32],\"isSliderActive\":[32]}],[0,\"vime-caption-control\",{\"showIcon\":[1,\"show-icon\"],\"hideIcon\":[1,\"hide-icon\"],\"tooltipPosition\":[1,\"tooltip-position\"],\"tooltipDirection\":[1,\"tooltip-direction\"],\"hideTooltip\":[4,\"hide-tooltip\"],\"keys\":[1],\"currentCaption\":[16],\"isCaptionsActive\":[4,\"is-captions-active\"],\"i18n\":[16]}],[0,\"vime-fullscreen-control\",{\"enterIcon\":[1,\"enter-icon\"],\"exitIcon\":[1,\"exit-icon\"],\"tooltipPosition\":[1,\"tooltip-position\"],\"tooltipDirection\":[1,\"tooltip-direction\"],\"hideTooltip\":[4,\"hide-tooltip\"],\"keys\":[1],\"isFullscreenActive\":[4,\"is-fullscreen-active\"],\"i18n\":[16],\"playbackReady\":[4,\"playback-ready\"],\"canSetFullscreen\":[32]}],[0,\"vime-pip-control\",{\"enterIcon\":[1,\"enter-icon\"],\"exitIcon\":[1,\"exit-icon\"],\"tooltipPosition\":[1,\"tooltip-position\"],\"tooltipDirection\":[1,\"tooltip-direction\"],\"hideTooltip\":[4,\"hide-tooltip\"],\"keys\":[1],\"isPiPActive\":[4,\"is-pi-p-active\"],\"i18n\":[16],\"playbackReady\":[4,\"playback-ready\"],\"canSetPiP\":[32]}],[0,\"vime-playback-control\",{\"playIcon\":[1,\"play-icon\"],\"pauseIcon\":[1,\"pause-icon\"],\"tooltipPosition\":[1,\"tooltip-position\"],\"tooltipDirection\":[1,\"tooltip-direction\"],\"hideTooltip\":[4,\"hide-tooltip\"],\"keys\":[1],\"paused\":[4],\"i18n\":[16]}],[0,\"vime-settings-control\",{\"icon\":[1],\"tooltipPosition\":[1,\"tooltip-position\"],\"tooltipDirection\":[1,\"tooltip-direction\"],\"menu\":[1],\"expanded\":[4],\"i18n\":[16]}],[4,\"vime-submenu\",{\"label\":[1],\"hidden\":[4],\"hint\":[1],\"active\":[1540]}],[0,\"vime-time-progress\",{\"separator\":[1],\"alwaysShowHours\":[4,\"always-show-hours\"]}],[0,\"vime-menu-radio\",{\"label\":[1],\"value\":[1],\"checked\":[1028],\"badge\":[1],\"checkedIcon\":[1,\"checked-icon\"]}],[0,\"vime-scrubber-control\",{\"alwaysShowHours\":[4,\"always-show-hours\"],\"hideTooltip\":[4,\"hide-tooltip\"],\"currentTime\":[2,\"current-time\"],\"duration\":[2],\"noKeyboard\":[4,\"no-keyboard\"],\"buffering\":[4],\"buffered\":[2],\"i18n\":[16],\"timestamp\":[32],\"endTime\":[32]}],[4,\"vime-settings\",{\"controlsHeight\":[2,\"controls-height\"],\"pin\":[513],\"active\":[1540],\"isMobile\":[4,\"is-mobile\"],\"isAudioView\":[4,\"is-audio-view\"],\"controllerId\":[32],\"setController\":[64]}],[4,\"vime-control-group\",{\"space\":[1]}],[0,\"vime-control-spacer\"],[4,\"vime-controls\",{\"hidden\":[4],\"fullWidth\":[4,\"full-width\"],\"fullHeight\":[4,\"full-height\"],\"direction\":[1],\"align\":[1],\"justify\":[1],\"pin\":[513],\"activeDuration\":[2,\"active-duration\"],\"waitForPlaybackStart\":[4,\"wait-for-playback-start\"],\"hideWhenPaused\":[4,\"hide-when-paused\"],\"hideOnMouseLeave\":[4,\"hide-on-mouse-leave\"],\"isAudioView\":[4,\"is-audio-view\"],\"isSettingsActive\":[4,\"is-settings-active\"],\"playbackReady\":[4,\"playback-ready\"],\"isControlsActive\":[4,\"is-controls-active\"],\"paused\":[4],\"playbackStarted\":[4,\"playback-started\"],\"isInteracting\":[32]}],[0,\"vime-live-indicator\",{\"isLive\":[4,\"is-live\"],\"i18n\":[16]}],[4,\"vime-menu-radio-group\",{\"value\":[1025]},[[0,\"vCheck\",\"onSelectionChange\"]]],[0,\"vime-scrim\",{\"gradient\":[1],\"isVideoView\":[4,\"is-video-view\"],\"isControlsActive\":[4,\"is-controls-active\"]}]]],[\"vime-audio_8.cjs\",[[4,\"vime-default-ui\",{\"noIcons\":[4,\"no-icons\"],\"noClickToPlay\":[4,\"no-click-to-play\"],\"noDblClickFullscreen\":[4,\"no-dbl-click-fullscreen\"],\"noCaptions\":[4,\"no-captions\"],\"noPoster\":[4,\"no-poster\"],\"noSpinner\":[4,\"no-spinner\"],\"noControls\":[4,\"no-controls\"],\"noSettings\":[4,\"no-settings\"],\"noSkeleton\":[4,\"no-skeleton\"]}],[0,\"vime-dash\",{\"src\":[1],\"version\":[1],\"config\":[16],\"autoplay\":[4],\"crossOrigin\":[1,\"cross-origin\"],\"preload\":[1],\"poster\":[1],\"controlsList\":[1,\"controls-list\"],\"autoPiP\":[4,\"auto-pip\"],\"disablePiP\":[4,\"disable-pip\"],\"disableRemotePlayback\":[4,\"disable-remote-playback\"],\"mediaTitle\":[1,\"media-title\"],\"hasAttached\":[32],\"getAdapter\":[64]},[[0,\"vMediaElChange\",\"onMediaElChange\"]]],[4,\"vime-hls\",{\"version\":[1],\"config\":[8],\"crossOrigin\":[1,\"cross-origin\"],\"preload\":[1],\"poster\":[1],\"controlsList\":[1,\"controls-list\"],\"autoPiP\":[4,\"auto-pip\"],\"disablePiP\":[4,\"disable-pip\"],\"disableRemotePlayback\":[4,\"disable-remote-playback\"],\"mediaTitle\":[1,\"media-title\"],\"hasAttached\":[32],\"getAdapter\":[64]},[[0,\"vMediaElChange\",\"onMediaElChange\"],[0,\"vSrcSetChange\",\"onSrcChange\"]]],[4,\"vime-audio\",{\"willAttach\":[4,\"will-attach\"],\"crossOrigin\":[1,\"cross-origin\"],\"preload\":[1],\"disableRemotePlayback\":[4,\"disable-remote-playback\"],\"mediaTitle\":[1,\"media-title\"],\"getAdapter\":[64]}],[0,\"vime-dailymotion\",{\"videoId\":[1,\"video-id\"],\"shouldAutoplayQueue\":[4,\"should-autoplay-queue\"],\"showUpNextQueue\":[4,\"show-up-next-queue\"],\"showShareButtons\":[4,\"show-share-buttons\"],\"color\":[1],\"syndication\":[1],\"showDailymotionLogo\":[4,\"show-dailymotion-logo\"],\"showVideoInfo\":[4,\"show-video-info\"],\"language\":[1],\"autoplay\":[4],\"controls\":[4],\"poster\":[1],\"logger\":[16],\"loop\":[4],\"muted\":[4],\"playsinline\":[4],\"embedSrc\":[32],\"mediaTitle\":[32],\"getAdapter\":[64]}],[0,\"vime-vimeo\",{\"videoId\":[1,\"video-id\"],\"byline\":[4],\"color\":[1],\"portrait\":[4],\"noAutoAspectRatio\":[4,\"no-auto-aspect-ratio\"],\"poster\":[1],\"language\":[1],\"aspectRatio\":[1,\"aspect-ratio\"],\"autoplay\":[4],\"controls\":[4],\"logger\":[16],\"loop\":[4],\"muted\":[4],\"playsinline\":[4],\"embedSrc\":[32],\"mediaTitle\":[32],\"getAdapter\":[64]}],[0,\"vime-youtube\",{\"cookies\":[4],\"videoId\":[1,\"video-id\"],\"showFullscreenControl\":[4,\"show-fullscreen-control\"],\"poster\":[1],\"language\":[1],\"autoplay\":[4],\"controls\":[4],\"logger\":[16],\"loop\":[4],\"muted\":[4],\"playsinline\":[4],\"embedSrc\":[32],\"mediaTitle\":[32],\"getAdapter\":[64]}],[4,\"vime-player\",{\"attached\":[1028],\"logger\":[16],\"theme\":[513],\"paused\":[1028],\"playing\":[1028],\"duration\":[1026],\"mediaTitle\":[1025,\"media-title\"],\"currentProvider\":[1025,\"current-provider\"],\"currentSrc\":[1025,\"current-src\"],\"currentPoster\":[1025,\"current-poster\"],\"currentTime\":[1026,\"current-time\"],\"autoplay\":[4],\"ready\":[1540],\"playbackReady\":[1028,\"playback-ready\"],\"loop\":[4],\"muted\":[1028],\"buffered\":[1026],\"playbackRate\":[1026,\"playback-rate\"],\"playbackRates\":[1040],\"playbackQuality\":[1025,\"playback-quality\"],\"playbackQualities\":[1040],\"seeking\":[1028],\"debug\":[4],\"playbackStarted\":[1028,\"playback-started\"],\"playbackEnded\":[1028,\"playback-ended\"],\"buffering\":[1028],\"controls\":[4],\"isControlsActive\":[4,\"is-controls-active\"],\"errors\":[1040],\"textTracks\":[1040],\"currentCaption\":[1040],\"isCaptionsActive\":[1028,\"is-captions-active\"],\"isSettingsActive\":[1028,\"is-settings-active\"],\"volume\":[1026],\"isFullscreenActive\":[1028,\"is-fullscreen-active\"],\"aspectRatio\":[1025,\"aspect-ratio\"],\"viewType\":[1025,\"view-type\"],\"isAudioView\":[1028,\"is-audio-view\"],\"isVideoView\":[1028,\"is-video-view\"],\"mediaType\":[1025,\"media-type\"],\"isAudio\":[1028,\"is-audio\"],\"isVideo\":[1028,\"is-video\"],\"isLive\":[1028,\"is-live\"],\"isMobile\":[1028,\"is-mobile\"],\"isTouch\":[1028,\"is-touch\"],\"isPiPActive\":[1028,\"is-pi-p-active\"],\"autopause\":[4],\"playsinline\":[4],\"language\":[1025],\"translations\":[1040],\"languages\":[1040],\"i18n\":[1040],\"shouldCheckForProviderChange\":[32],\"getProvider\":[64],\"setProvider\":[64],\"getAdapter\":[64],\"play\":[64],\"pause\":[64],\"canPlay\":[64],\"canAutoplay\":[64],\"canMutedAutoplay\":[64],\"canSetPlaybackRate\":[64],\"canSetPlaybackQuality\":[64],\"canSetFullscreen\":[64],\"enterFullscreen\":[64],\"exitFullscreen\":[64],\"canSetPiP\":[64],\"enterPiP\":[64],\"exitPiP\":[64],\"extendLanguage\":[64],\"callAdapter\":[64],\"toggleCaptionsVisibility\":[64]},[[0,\"vMediaProviderConnect\",\"onMediaProviderConnect\"],[0,\"vMediaProviderDisconnect\",\"onMediaProviderDisconnect\"],[0,\"vLoadStart\",\"onMediaChange\"],[0,\"vStateChange\",\"onStateChange\"],[0,\"vProviderChange\",\"onProviderChange\"]]]]],[\"vime-playground.cjs\",[[0,\"vime-playground\",{\"provider\":[1025],\"src\":[1025],\"showCustomUI\":[1028,\"show-custom-u-i\"],\"theme\":[1025],\"poster\":[1025]}]]],[\"vime-faketube.cjs\",[[0,\"vime-faketube\",{\"language\":[1],\"autoplay\":[4],\"controls\":[4],\"logger\":[16],\"loop\":[4],\"muted\":[4],\"playsinline\":[4],\"getAdapter\":[64],\"dispatchLoadStart\":[64],\"dispatchChange\":[64]}]]]]"), options);
});
